{
Copyright  Frdric MONTIN, 2006

dekibulle@free.fr
http://dekibulle.free.fr

**fr**

Ce logiciel est un programme informatique servant  lire des fichiers
audio sur ordinateur.

Ce fichier est une partie de dkibulle.

Dkibulle est un logiciel libre; soumis  une double licence. 
Vous pouvez le redistribuer ainsi que le modifier ds lors que vous respectez 
les termes *de l'une des deux licences*
- *soit* la licence GNU Lesser General Public License comme publie par la 
  Free Software Foundation, dans sa version 2 ou ultrieure; 
- *soit* la licence Cecill-C comme publie par Cecill,
  dans sa version 1 ou ultrieure.

**en**

This software is a computer program whose purpose is to listen audio
files on a computer.

This file is a part of Dkibulle.

Dkibulle is a free software; subjected to a double license.
You can redistribute it and/or modify since you respect the terms of either 
(at least one of the both license) :
- the GNU Lesser General Public License as published by the Free Software Foundation; 
  either version 2.1 of the License, or any later version. 
- the CeCILL-C as published by CeCILL; either version 1 of the License, or any later version.
}

unit DeKiBulleUtils;

interface

Uses  Windows, Classes, Graphics, Messages, URLMon, Dialogs, StrUtils,
      SysUtils, IniFiles, Forms, Controls, ShellAPI, ID3v1, ID3v2, WMAFile, OGGVorbis,
      Unit1, Unit2, Unit3, Unit4, Unit5, Bass, Registry;

function  Split(S: string; d: Pchar): TStringList;
function  NomFichierSon(F: string): string;
function  ValideExt(const F: string): boolean;
procedure GestionLangue(Index : integer = 0);
procedure MiseaJoursCouleurs(Totale : Boolean = True);
procedure Executer(const action : string);
function  GetGenreFromIndex(Index : integer): string;
function  GetIndexofGenre(const Genre : String): byte;
procedure SetEqualizer;
function  CheckVersion(const AffSiNon : Boolean = True): Boolean;

const
  SGenre : array[0..148] of string = ('Blues','Classic Rock','Country','Dance','Disco','Funk','Grunge',
    'Hip-Hop','Jazz','Metal','New Age','Oldies','Other','Pop','R&B','Rap','Reggae','Rock','Techno',
    'Industrial','Alternative','Ska','Death Metal','Pranks','Soundtrack','Euro-Techno','Ambient','Trip-Hop',
    'Vocal','Jazz+Funk','Fusion','Trance','Classical','Instrumental','Acid','House','Game','Sound Clip',
    'Gospel','Noise','AlternRock','Bass','Soul','Punk','Space','Meditative','Instrumental Pop',
    'Instrumental Rock','Ethnic','Gothic','Darkwave','Techno-Industrial','Electronic','Pop-Folk','Eurodance',
    'Dream','Southern Rock','Comedy','Cult','Gangsta','Top 40','Christian Rap','Pop/Funk','Jungle',
    'Native American','Cabaret','New Wave','Psychadelic','Rave','Showtunes','Trailer','Lo-Fi','Tribal',
    'Acid Punk','Acid Jazz','Polka','Retro','Musical','Rock & Roll','Hard Rock','Folk','Folk-Rock',
    'National Folk','Swing','Fast Fusion','Bebob','Latin','Revival','Celtic','Bluegrass','Avantgarde',
    'Gothic Rock','Progressive Rock','Psychedelic Rock','Symphonic Rock','Slow Rock','Big Band','Chorus',
    'Easy Listening','Acoustic','Humour','Speech','Chanson','Opera','Chamber Music','Sonata','Symphony',
    'Booty Bass','Primus','Porn Groove','Satire','Slow Jam','Club','Tango','Samba','Folklore','Ballad',
    'Power Ballad','Rhythmic Soul','Freestyle','Duet','Punk Rock','Drum Solo','A capella','Euro-House',
    'Dance Hall','Goa','Drum & Bass','Club-House','Hardcore','Terror','Indie','BritPop','Negerpunk',
    'Polsk Punk','Beat','Christian Gangsta Rap','Heavy Metal','Black Metal','Crossover',
    'Contemporary Christian','Christian Rock','Merengue','Salsa','Thrash Metal','Anime','JPop','Synthpop','Unknow');

implementation

{------------------------------------------------------------------------}
{       fonction Split                                                   }
{------------------------------------------------------------------------}
function Split(S: string; d: Pchar): TStringList;
var
    Spliti: integer;
    Splitt: string;
begin
    Result := TStringList.Create;
    Splitt := '';
    for Spliti := 1 to Length(S) do begin  // une string a commence  1...
        if S[Spliti] = d then begin
            if Splitt <> '' then begin
                Result.Add(Splitt);
                Splitt := '';
            end;
        end else
            Splitt := Splitt + S[Spliti];
    end;
    if Splitt <> '' then
        Result.Add(Splitt);
end;

//============================================================================//
{             Renvoie le nom d'un fichier son  afficher                       }
//----------------------------------------------------------------------------//
function NomFichierSon(F: string): string;
var
    MP3Tagv1 : TID3v1;
    MP3Tagv2 : TID3v2;
    WMATag   : TWMAfile;
    OGGTag   : TOggVorbis;
    Ext      : string;
    n        : TstringList;
    Rapide   : Boolean;
begin
    Application.ProcessMessages;
    Rapide := Not(OptionLireMetaTags);
        { Est-ce que le fichier existe ? }
    if not(FileExists(F)) then begin
        Result := 'No File...';
        Exit;
    end;

    Ext := LowerCase(ExtractFileExt(F));

        { Si le fichier est un cda (CD audio)  }
    if AnsiContainsText('$.cda$', Ext) then begin
        Result := Format('CD Audio - %s', [Copy(F, 1, Length(F) - Length(ExtractFileExt(F)))]);
        Exit;
    end;

        { Si le fichier est un mp3 ou mp2 on tente de regarder les TAG ID3 v2 }
    if (AnsiContainsText('$.mp3$.mp2$', Ext) and Not(Rapide)) then begin
            { Lecture TAG ID3 v2 }
        MP3Tagv2 := TID3v2.Create;
        With MP3Tagv2 do begin
            ReadFromFile(F);
            if (Exists) and (Trim(Title) <> '') then begin
                if Track > 0 then
                    Result := Format('%s - %s - %.2d - %s', [Artist, Album, Track, Title])
                else
                    Result := Format('%s - %s - %s', [Artist, Album, Title]);
                Free;
                Exit;
            end;
            Free;
        end;
    end;

        { Si le fichier est un mp3 ou mp2 ou mpc on tente de regarder les TAG ID3 v1.1 }
    if (AnsiContainsText('$.mp3$.mp2$.mpc$', Ext) and Not(Rapide)) then begin
            { Lecture TAG ID3 v1.1 }
        MP3Tagv1 := TID3v1.Create;
        With MP3Tagv1 do begin
            ReadFromFile(F);
            if (Exists) and (Trim(Title) <> '') then begin
                if Track > 0 then
                    Result := Format('%s - %s - %.2d - %s', [Trim(Artist), Trim(Album), Track, Trim(Title)])
                else
                    Result := Format('%s - %s - %s', [Trim(Artist), Trim(Album), Trim(Title)]);
                Free;
                Exit;
            end;
            Free;
        end;
    end;

        { Si le fichier est un wma on tente de regarder les TAG }
    if (AnsiContainsText('$.wma$', Ext) and Not(Rapide)) then begin
        WMATag := TWMAfile.Create;
        With WMATag do begin
            ReadFromFile(F);
            if (Valid) and (Trim(Title) <> '') then begin
                if Track > 0 then
                    Result := Format('%s - %s - %.2d - %s', [Trim(Artist), Trim(Album), Track, Trim(Title)])
                else
                    Result := Format('%s - %s - %s', [Trim(Artist), Trim(Album), Trim(Title)]);
                Free;
                Exit;
            end;
            Free;
        end;
    end;

        { Si le fichier est un ogg on tente de regarder les TAG }
    if (AnsiContainsText('$.ogg$', Ext) and Not(Rapide)) then begin
        OGGTag := TOggVorbis.Create;
        With OGGTag do begin
            ReadFromFile(F);
            if (Valid) and (Trim(Title) <> '') then begin
                if Track > 0 then
                    Result := Format('%s - %s - %.2d - %s', [Trim(Artist), Trim(Album), Track, Trim(Title)])
                else
                    Result := Format('%s - %s - %s', [Trim(Artist), Trim(Album), Trim(Title)]);
                Free;
                Exit;
            end;
            Free;
        end;
    end;

        { Pas de TAGs du tout ou Rapide }
        { Lecture du chemin du fichier }
        { On suppose que le chemin est : ARTISTE\ALBUM\CHANSON.mp3 }
    n := Split(F, '\');
    F := ExtractFileName(F);
    With n do begin
      if Count > 3 then
        Result := Format('%s - %s - %s', [Strings[Count - 3], Strings[Count - 2], Copy(F, 1, Length(F) - Length(ExtractFileExt(F)))])
      else
        Result := Copy(F, 1, Length(F) - Length(ExtractFileExt(F)));
      Free;
    end;

end;

//============================================================================//
{             Valide l'extension d'un fichier                                  }
//----------------------------------------------------------------------------//
function ValideExt(const F: string) : boolean;
var
    i : integer;
    E : string[5];
begin
    E := LowerCase(ExtractFileExt(F));
    for i := 0 to VEXT.Count - 1 do begin
        if E = '.' + VEXT[i] then begin
            Result := true;
            Exit;
        end;
    end;
    Result := false;
end;

//============================================================================//
{                  Gestion de la langue                                        }
//----------------------------------------------------------------------------//
procedure GestionLangue(Index : integer = 0);
var
    IniLangue: TIniFile;
    i        : integer;
begin
            { Gestion de la Langue }
    IniLangue := TiniFile.Create(FichierLangue);
    with IniLangue do begin
        if (Index = 0) or (Index = 1) then begin
                    { Popup Menu }
          With Form1 do begin
            MenuAfficher.Caption       := ReadString('MENU', 'MenuAfficher', 'Afficher');
            MenuResteAffichee.Caption  := ReadString('MENU', 'MenuResteAffichee', 'Reste affiche');
            MenuOptions.Caption        := ReadString('MENU', 'MenuOptions', 'Options');
            MenuPlayPause.Caption      := ReadString('MENU', 'MenuPlayPause', 'Lecture / Pause');
            MenuQuitter.Caption        := ReadString('MENU', 'MenuQuitter', 'Quitter');
            MenuShuffle.Caption        := ReadString('MENU', 'MenuShuffle', 'Lecture alatoire');
            MenuLectureBoucle.Caption  := ReadString('MENU', 'MenuLectureBoucle', 'Lecture en boucle');

                    { Popup Menu liste des rpertoires }
            MenuMettreSuite.Caption := ReadString('MENU', 'MenuMettreSuite', 'Mettre  la suite');
            MenuLireRep.Caption     := ReadString('MENU', 'MenuLireRep', 'Lire le contenu');
            MenuChansons.Caption    := ReadString('MENU', 'MenuChansons', 'Chansons');
            MenuExplorerRep.Caption := ReadString('MENU', 'MenuExplorerRep', 'Explorer le rpertoire');
            MenuGererRep.Caption    := ReadString('MENU', 'MenuGererRep', 'Grer les rpertoires');
            MenuRefreshRep.Caption  := ReadString('MENU', 'MenuRefresh', 'Rafrachir');

                    { Popup Menu liste de lecture }
            MenuEcouterChanson.Caption   := ReadString('MENU', 'MenuEcouterChanson', 'Ecouter');
            MenuEditeurTag.Caption       := ReadString('MENU', 'MenuEditeurTag', 'Editeur de tag MP3/OGG');
            MenuSelectAll.Caption        := ReadString('MENU', 'MenuSelectAll', 'Slectionner tout');
            MenuSupprimerChanson.Caption := ReadString('MENU', 'MenuSupprimerChanson', 'Supprimer la slection');
            MenuOuvrirFichier.Caption    := ReadString('MENU', 'MenuOuvrirFichier', 'Ouvrir un fichier');
            MenuSauverListe.Caption      := ReadString('MENU', 'MenuSauverListe', 'Sauver la playliste');
            MenuRefreshListe.Caption     := ReadString('MENU', 'MenuRefresh', 'Rafrachir');

                    { Main Form }
            SpdBtnRep.Hint       := ReadString('MAIN', 'SpdBtnRep', 'Rpertoires');
            SpdBtnListe.Hint     := ReadString('MAIN', 'SpdBtnListe', 'Playliste');
            SpdBtnPrev.Hint      := ReadString('MAIN', 'SpdBtnPrev', 'Prcdente');
            SpdBtnPlay.Hint      := ReadString('MAIN', 'SpdBtnPlay', 'Lecture / Pause');
            SpdBtnNext.Hint      := ReadString('MAIN', 'SpdBtnNext', 'Suivante');
            ProgressBar1.Hint    := ReadString('MAIN', 'ProgressBar1', 'Position');
            ProgressBar2.Hint    := ReadString('MAIN', 'ProgressBar2', 'Volume');
            SpdBtnEgaliseur.Hint := ReadString('MAIN', 'SpdBtnEgaliseur', 'Egaliseur');
            SpdBtnOptions.Hint   := ReadString('MAIN', 'SpdBtnOptions', 'Options');
          end;
        end;
        if (Index = 0) or (Index = 2) then begin
                    { Nom Form Options }
          with Form2 do begin
            Caption := 'DKiBulle - ' + ReadString('OPTION', 'Page0', 'Options');

                    { Options Onglet 1 }
            TabbedNotebook1.Pages.Strings[0] := ReadString('OPTION', 'Page0', 'Options');

            GroupBox7.Caption                  := ReadString('OPTION', 'GroupBox7', 'Autres');
            CheckBallon.Caption                := ReadString('OPTION', 'CheckBallon', 'Afficher ballon');
            CheckSousRep.Caption               := ReadString('OPTION', 'CheckSousRep', 'Inclure sous-rpertoires');
            CheckLireMetaTags.Caption          := ReadString('OPTION', 'CheckLireMetaTags', 'Lire les meta tags');
            CheckShuffle.Caption               := ReadString('OPTION', 'CheckShuffle', 'Lecture alatoire');
            CheckLectureBoucle.Caption         := ReadString('OPTION', 'CheckLectureBoucle', 'Lecture en boucle');
            CheckNouvelleVersion.Caption       := ReadString('OPTION', 'CheckNouvelleVersion', 'Vrification automatique nouvelle version');
            CheckApparitionProgressive.Caption := ReadString('OPTION', 'CheckApparitionProgressive', 'Apparition progressive de la fentre');

            GroupBox8.Caption := ReadString('OPTION', 'GroupBox8', 'Langues');

            RadioGroup1.Caption          := ReadString('OPTION', 'RadioGroup1', 'Dmarrer avec windows');
            RadioGroup1.Items.Strings[0] := ReadString('OPTION', 'RadioGroup1Item0', 'Oui');
            RadioGroup1.Items.Strings[1] := ReadString('OPTION', 'RadioGroup1Item1', 'Non');

                    { Options Onglet 2 }
            TabbedNotebook1.Pages.Strings[1] := ReadString('OPTION', 'Page1', 'Raccourcis');

            GroupBox6.Caption := ReadString('OPTION', 'GroupBox6', 'Raccourcis clavier');
            CheckBox1.Caption := ReadString('OPTION', 'CheckBox1', 'Lecture/Pause');
            CheckBox2.Caption := ReadString('OPTION', 'CheckBox2', 'Prcdente');
            CheckBox3.Caption := ReadString('OPTION', 'CheckBox3', 'Suivante');
            CheckBox4.Caption := ReadString('OPTION', 'CheckBox4', 'Volume +');
            CheckBox5.Caption := ReadString('OPTION', 'CheckBox5', 'Volume -');
            CheckBox6.Caption := ReadString('OPTION', 'CheckBox6', 'Afficher/Cacher');
            CheckBox7.Caption := ReadString('OPTION', 'CheckBox7', 'Avancer rapidement');
            CheckBox8.Caption := ReadString('OPTION', 'CheckBox8', 'Reculer rapidement');

                    { Options Onglet 3 }
            TabbedNotebook1.Pages.Strings[2] := ReadString('OPTION', 'Page2', 'Rpertoires');

            GroupBox1.Caption        := ReadString('OPTION', 'GroupBox1', 'Rpertoire de base');
            ButtonSupprRep.Caption   := ReadString('OPTION', 'ButtonSupprRep', 'Supprimer');
            ButtonAjouterRep.Caption := ReadString('OPTION', 'ButtonAjouterRep', 'Ajouter');

                    { Options Onglet 4 }
            TabbedNotebook1.Pages.Strings[3] := ReadString('OPTION', 'Page3', 'Affichages');

            GroupBox4.Caption      := ReadString('OPTION', 'GroupBox4', 'Couleurs liste des rpertoires');
            BtnClFondRep.Caption   := ReadString('OPTION', 'BtnClFondRep', 'Fond');
            BtnClTexteRep.Caption  := ReadString('OPTION', 'BtnClTexteRep', 'Texte');
            BtnClSurvolRep.Caption := ReadString('OPTION', 'BtnClSurvolRep', 'Survol');
            LabelDemoRep.Caption   := ReadString('OPTION', 'LabelDemoRep', 'Exemple');

            GroupBox2.Caption         := ReadString('OPTION', 'GroupBox2', 'Couleurs liste de lecture');
            BtnClFondListe.Caption    := ReadString('OPTION', 'BtnClFondListe', 'Fond');
            BtnClTexteListe.Caption   := ReadString('OPTION', 'BtnClTexteListe', 'Texte');
            BtnClPlayingListe.Caption := ReadString('OPTION', 'BtnClPlayingListe', 'Charg');
            LabelDemoListe.Caption    := ReadString('OPTION', 'LabelDemoListe', 'Exemple');

            GroupBox3.Caption        := ReadString('OPTION', 'GroupBox3', 'Police des listes');
            BtnChangerPolice.Caption := ReadString('OPTION', 'BtnChangerIcone', 'Changer');
            BtnPoliceDefaut.Caption  := ReadString('OPTION', 'BtnIconeDefaut', 'Par dfaut');

            GroupBox5.Caption        := ReadString('OPTION', 'GroupBox5', 'Couleurs des barres');
            BtnColorProgress.Caption := ReadString('OPTION', 'BtnColorProgress', 'Progression');
            BtnColorVolume.Caption   := ReadString('OPTION', 'BtnColorVolume', 'Volume');

            GroupBox9.Caption        := ReadString('OPTION', 'GroupBox9', 'Icne de la barre des tches');
            BtnChangerIcone.Caption  := ReadString('OPTION', 'BtnChangerIcone', 'Changer');
            BtnIconeDefaut.Caption   := ReadString('OPTION', 'BtnIconeDefaut', 'Par dfaut');
            CheckAnimerIcone.Caption := ReadString('OPTION', 'CheckAnimerIcone', 'Animer l''icne pendant la lecture');

                    { Options Onglet 5 }
            TabbedNotebook1.Pages.Strings[4] := ReadString('OPTION', 'Page4', 'Associations');

            GroupBoxEXT.Caption              := ReadString('OPTION', 'GroupBoxEXT', 'Associations avec les fichiers audio');

            GroupBox10.Caption              := ReadString('OPTION', 'GroupBox10', 'Icne des fichiers associs  DKiBulle');
            BtnChangerIconeFichiers.Caption := ReadString('OPTION', 'BtnChangerIcone', 'Changer');
            BtnIconeFichiersDefaut.Caption  := ReadString('OPTION', 'BtnIconeDefaut', 'Par dfaut');

            RadioGroupCDAudio.Caption          := ReadString('OPTION', 'RadioGroupCDAudio', 'Association avec les CD Audio');
            RadioGroupCDAudio.Items.Strings[0] := ReadString('OPTION', 'RadioGroup1Item0', 'Oui');
            RadioGroupCDAudio.Items.Strings[1] := ReadString('OPTION', 'RadioGroup1Item1', 'Non');

            RadioGroupRepertoires.Caption          := ReadString('OPTION', 'RadioGroupRepertoires', 'Association avec les rpertoires');
            RadioGroupRepertoires.Items.Strings[0] := ReadString('OPTION', 'RadioGroup1Item0', 'Oui');
            RadioGroupRepertoires.Items.Strings[1] := ReadString('OPTION', 'RadioGroup1Item1', 'Non');

                    { Options Onglet 6 }
            TabbedNotebook1.Pages.Strings[5] := ReadString('OPTION', 'Page5', 'A propos...');

            RichEdit1.Lines.Clear;
            RichEdit1.SelAttributes.Style := [fsBold];
            RichEdit1.Lines.Add('DKiBulle v' + Version);
            RichEdit1.Lines.Add('Copyright  Frdric MONTIN, 2006');
            RichEdit1.Lines.Add('');
            i := 100;
            while ValueExists('APROPOS', IntToStr(i)) do begin
                RichEdit1.Lines.Add(ReadString('APROPOS',  inttostr(i), ''));
                Inc(i);
            end;
            SendMessage(RichEdit1.Handle, WM_VSCROLL, SB_TOP, 0); // On scroll tout en haut
            LabelWebVersion.Caption := ReadString('OPTION', 'LabelWebVersion', 'Nouvelle version ?');
            LabelLicense.Caption    := ReadString('OPTION', 'LabelLicense', 'Afficher licence');
          end;
        end;
        if (Index = 0) or (Index = 3) then begin
                    { Form ID3 Tag }
          with FormTag do begin
            Caption               := ReadString('MENU', 'MenuEditeurTag', 'Editeur de mta tags');
            CheckArtistv1.Caption := ReadString('ID3TAG', 'CheckArtist', 'Artiste');
            CheckAlbumv1.Caption  := ReadString('ID3TAG', 'CheckAlbum', 'Album');
            CheckTitrev1.Caption  := ReadString('ID3TAG', 'CheckTitre', 'Titre');
            CheckAnneev1.Caption  := ReadString('ID3TAG', 'CheckAnnee', 'Anne');
            CheckComv1.Caption    := ReadString('ID3TAG', 'CheckCom', 'Commentaires');
            CheckGenrev1.Caption  := ReadString('ID3TAG', 'CheckGenre', 'Genre');
            CheckArtistv2.Caption := CheckArtistv1.Caption;
            CheckAlbumv2.Caption  := CheckAlbumv1.Caption;
            CheckTitrev2.Caption  := CheckTitrev1.Caption;
            CheckAnneev2.Caption  := CheckAnneev1.Caption;
            CheckComv2.Caption    := CheckComv1.Caption;
            CheckGenrev2.Caption  := CheckGenrev1.Caption;
            GroupBox3.Caption     := ReadString('ID3TAG', 'GroupBox3', 'Infos fichier');
            GroupBox4.Caption     := ReadString('ID3TAG', 'GroupBox4', 'Liste des fichiers');
            BtnSave.Caption       := ReadString('ID3TAG', 'BtnSave', 'Enregistrer');
            BtnClose.Caption      := ReadString('ID3TAG', 'BtnClose', 'Fermer');
          end;
        end;
        if (Index = 0) or (Index = 4) then begin
                    { Form Equalizer }
            FormEqualizer.Caption := ReadString('MAIN', 'SpdBtnEgaliseur', 'Egaliseur');
        end;
        Free;
    end;   // fin with IniLangue
end;

//============================================================================//
{                  Mise  jours des couleurs et des icnes                     }
//----------------------------------------------------------------------------//
procedure MiseaJoursCouleurs(Totale : Boolean = True);
var
    Ini: Tinifile;
    F  : String;
begin
            { Mise  jours des couleurs et polices }
    Ini := Tinifile.Create(FichierIni);
    with Ini do begin
                { Form 1 }
      With Form1 do begin
        TreeView1.Color          := ReadInteger('DATA', 'BtnClFondRep',      13225925);
        TreeView1.Font.Color     := ReadInteger('DATA', 'BtnClTexteRep',     6244901);
        TreeView1.Tag            := ReadInteger('DATA', 'BtnClSurvolRep',    128);
        Listbox1.Color           := ReadInteger('DATA', 'BtnClFondListe',    7362860);
        Listbox1.Font.Color      := ReadInteger('DATA', 'BtnClTexteListe',   13225925);
        Listbox1.Tag             := ReadInteger('DATA', 'BtnClPlayingListe', 33023);
        ProgressBar1.Brush.Color := clGray;
        ProgressBar2.Brush.Color := clGray;
        SendMessage(ProgressBar1.Handle, WM_USER + 9, 0, ReadInteger('DATA', 'BtnColorProgress', 13225925));
        SendMessage(ProgressBar2.Handle, WM_USER + 9, 0, ReadInteger('DATA', 'BtnColorVolume',   7362860));
        TreeView1.Font.Name := ReadString('DATA', 'PoliceName', 'Tahoma');
        TreeView1.Font.Size := ReadInteger('DATA', 'PoliceSize', 8);
        Listbox1.Font.Name  := TreeView1.Font.Name;
        Listbox1.Font.Size  := TreeView1.Font.Size;
        ListBox1.Repaint;
        TreeView1.Repaint;
        if Totale then begin
                { Form InfoBulle }
          With FormInfoBulle do begin
            Color             := Listbox1.Color;
            Label1.Font.Color := Listbox1.Font.Color;
            Shape1.Pen.Color  := Label1.Font.Color;
            Label1.Font.Name  := TreeView1.Font.Name;
            Label1.Font.Size  := TreeView1.Font.Size;
          end;
                { Form 2 }
          With Form2 do begin
            LabelDemoRep.Color        := TreeView1.Color;
            LabelDemoRep.Font.Color   := TreeView1.Font.Color;
            LabelDemoRep.Font.Name    := TreeView1.Font.Name;
            LabelDemoRep.Font.Size    := TreeView1.Font.Size;
            LabelDemoListe.Color      := Listbox1.Color;
            LabelDemoListe.Font.Color := Listbox1.Font.Color;
            LabelDemoListe.Font.Name  := Listbox1.Font.Name;
            LabelDemoListe.Font.Size  := Listbox1.Font.Size;
            F := ReadString('DATA', 'IconeFichiersAssocies', '');
            if FileExists(F) then
                ImageIconeFichiers.Picture.Icon.LoadFromFile(F)
            else
                ImageIconeFichiers.Picture.Icon := Form2.Icon;
            F := ReadString('DATA', 'Icone', '');
            if FileExists(F) then
                ImageIconeBarreDesTaches.Picture.Icon.LoadFromFile(F)
            else
                ImageIconeBarreDesTaches.Picture.Icon := Form2.Icon;
          end; // end with form2

                  { Icone barre des tches }
          if FileExists(ReadString('DATA', 'Icone', '')) then
              Icon.LoadFromFile(ReadString('DATA', 'Icone', ''))
          else
              Icon := Form2.Icon;
          With TrayIcon1 do begin
              Icon := Form1.Icon;
              BackgroundIcon := Icon;
          end;

        end; // end if Totale
      end; // end with form1
    end; // end with Ini
    Ini.Free;
end;

//============================================================================//
{                  Executer une commande                                       }
//----------------------------------------------------------------------------//
procedure Executer(const action : string);
begin
    Screen.Cursor := crHourGlass;
    ShellExecute(Form1.Handle, Nil, PChar(action), Nil, Nil, SW_SHOWNORMAL);
    Screen.Cursor := crDefault;
end;

//============================================================================//
{                  Renvoi le genre d'un chanson (ID3v1)                        }
//----------------------------------------------------------------------------//
function GetGenreFromIndex(Index : integer) : string;
begin
    if ((Index < 0) or (Index > 148)) then Index := 148;
    Result := SGenre[Index];
end;

function GetIndexofGenre(const Genre : String) : byte;
var
    i : integer;
begin
    for i := Low(SGenre) to High(SGenre) do
        if LowerCase(Genre) = LowerCase(SGenre[i]) then begin
            Result := i;
            Exit;
        end;
    Result := 148;
end;


//============================================================================//
{                  Active l'galiseur                                          }
//----------------------------------------------------------------------------//
procedure SetEqualizer;
begin
  With Form1 do
    if Channel <> 0 then begin
        fx[1] := BASS_ChannelSetFX(Form1.Channel, BASS_FX_PARAMEQ, 1);
        fx[2] := BASS_ChannelSetFX(Form1.Channel, BASS_FX_PARAMEQ, 1);
        fx[3] := BASS_ChannelSetFX(Form1.Channel, BASS_FX_PARAMEQ, 1);
        p.fBandwidth := 18;
        p.fGain := eq[1];
        p.fCenter := 125;
        BASS_FXSetParameters(fx[1], @p);
        p.fGain := eq[2];
        p.fCenter := 1000;
        BASS_FXSetParameters(fx[2], @p);
        p.fGain := eq[3];
        p.fCenter := 8000;
        BASS_FXSetParameters(fx[3], @p);
    end;
end;

//============================================================================//
{          Vrifie si une nouvelle version est en ligne                        }
//----------------------------------------------------------------------------//
function CheckVersion(const AffSiNon : Boolean = True): Boolean;
var
    v         : TStringList;
    f, t      : string;
    IniLangue : TIniFile;
begin
    Screen.Cursor := crHourGlass;
    IniLangue     := TiniFile.Create(FichierLangue);
    f             := ExtractFilePath(Application.ExeName) + 'version.txt';
    URLDownloadToFile(nil, pchar('http://dekibulle.free.fr/version.php'), PChar(f), 0, nil);
    if FileExists(f) then begin
        Result := True;
        v      := TStringList.Create;
        v.LoadFromFile(f);
        Application.ProcessMessages;
        DeleteFile(f);
        if v[0] <> Version then begin
            t := IniLangue.ReadString('MESSAGES', '16', 'Nouvelle version disponible') + #13#10 + #13#10 + IniLangue.ReadString('MESSAGES', '17', 'Ouvrir le site?');
            if MessageDlg(t, mtInformation, [mbYes, mbNo], 0) = mrYes then
                Executer('http://dekibulle.free.fr');
        end else begin
            t := IniLangue.ReadString('MESSAGES', '18', 'Dernire version');
            if AffSiNon then
                MessageDlg(t, mtInformation, [mbOK], 0);
        end;
        v.Free;
    end else begin
        t      := IniLangue.ReadString('MESSAGES', '19', 'Erreur') + #13#10 + #13#10 + IniLangue.ReadString('MESSAGES', '17', 'Ouvrir le site?');
        Result := False;
        if AffSiNon then
            if MessageDlg(t, mtWarning, [mbYes, mbNo], 0) = mrYes then
                Executer('http://dekibulle.free.fr');
    end;
    IniLangue.Free;
    Screen.Cursor := crDefault;
end;


end.
